---
title: WritableStreamDefaultController.error()
slug: Web/API/WritableStreamDefaultController/error
tags:
  - API
  - Error
  - Experimental
  - Method
  - Reference
  - Streams
  - WritableStreamDefaultController
---
<div>{{draft}}{{SeeCompatTable}}{{APIRef("Streams")}}</div>

<p class="summary">The <strong><code>error()</code></strong> method of the {{domxref("WritableStreamDefaultController")}} interface causes any future interactions with the associated stream to error.</p>

<p>This method is rarely used, since usually it suffices to return a rejected promise from one of the underlying sink’s methods. However, it can be useful for suddenly shutting down a stream in response to an event outside the normal lifecycle of interactions with the underlying sink.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>writableStreamDefaultController</em>.error(<em>e</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>e</dt>
 <dd>A {{domxref("DOMString")}} representing the error you want future interactions to fail with.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p><code>undefined</code>.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt>TypeError</dt>
 <dd>The stream you are trying to error is not a {{domxref("WritableStream")}}.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush: js line-numbers  language-js"><code class="language-js"><span class="keyword token">const</span> writableStream <span class="operator token">=</span> <span class="keyword token">new</span> <span class="class-name token">WritableStream</span><span class="punctuation token">(</span><span class="punctuation token">{</span>
  <span class="function token">start</span><span class="punctuation token">(</span>controller<span class="punctuation token">)</span> <span class="punctuation token">{</span>
    <span class="comment token">// do stuff with controller</span>

    <span class="comment token">// error stream if necessary</span>
    controller<span class="punctuation token">.</span><span class="function token">error</span><span class="punctuation token">(</span><span class="string token">'My error is broken'</span><span class="punctuation token">)</span><span class="punctuation token">;</span>
  <span class="punctuation token">}</span><span class="punctuation token">,</span>
  <span class="function token">write</span><span class="punctuation token">(</span>chunk<span class="punctuation token">,</span> controller<span class="punctuation token">)</span> <span class="punctuation token">{</span>
    <span class="punctuation token">.</span><span class="punctuation token">.</span><span class="punctuation token">.</span>
  <span class="punctuation token">}</span><span class="punctuation token">,</span>
  <span class="function token">close</span><span class="punctuation token">(</span>controller<span class="punctuation token">)</span> <span class="punctuation token">{</span>
    <span class="punctuation token">.</span><span class="punctuation token">.</span><span class="punctuation token">.</span>
  <span class="punctuation token">}</span><span class="punctuation token">,</span>
  <span class="function token">abort</span><span class="punctuation token">(</span>err<span class="punctuation token">)</span> <span class="punctuation token">{</span>
    <span class="punctuation token">.</span><span class="punctuation token">.</span><span class="punctuation token">.</span>
  <span class="punctuation token">}</span>
<span class="punctuation token">}</span><span class="punctuation token">)</span><span class="punctuation token">;</span></code></pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Streams","#ws-default-controller-error","error()")}}</td>
   <td>{{Spec2('Streams')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.WritableStreamDefaultController.error")}}</p>
